Attribute VB_Name = "Module1"
Type rect
    left As Single
    top As Single
    right As Single
    bottom As Single
End Type

Private Sub cpyImage(img As VB.Image, target As VB.PictureBox)
    
    If img.stretch Then
        target.PaintPicture img.picture, img.left, img.top, img.width, img.height
    Else
        target.PaintPicture img.picture, img.left, img.top
    End If
    
End Sub

Private Sub cpyPictureBox(pic As VB.PictureBox, target As VB.PictureBox)
    target.PaintPicture pic.picture, pic.left, pic.top, , , , , pic.width, pic.height
        'target.PaintPicture pic.picture, pic.left, pic.top

End Sub
Public Function getPicture(source As PictureBox, target As PictureBox, controls As Object) As StdPicture
'    Dim ctl As Control
'
'    For Each ctl In controls
'        If ctl.Container.Name = source.Name Then
'            If TypeOf ctl Is VB.Label Then
'                cpyLabel ctl, target
'            ElseIf TypeOf ctl Is VB.Shape Then
'                cpyShape ctl, target
'            End If
'        End If
'    Next ctl

'Recorro la coleccion asi, porque de esta forma, me devuelve los controles
'en el orden en que fueron creados, y asi, puedo conocer el orden Z.
    Dim i As Integer, ctl As VB.Control

    For i = controls.Count - 1 To 0 Step -1
        Set ctl = controls(i)
        If ctl.Container.Name = source.Name Then
            If TypeOf ctl Is VB.Label Then
                cpyLabel ctl, target
            ElseIf TypeOf ctl Is VB.Shape Then
                cpyShape ctl, target
            ElseIf TypeOf ctl Is VB.Line Then
                cpyLine ctl, target
            ElseIf TypeOf ctl Is VB.Image Then
                cpyImage ctl, target
            ElseIf TypeOf ctl Is VB.PictureBox Then
                cpyPictureBox ctl, target
            End If
        End If
    Next i
End Function

Private Sub cpyLabel(lbl As VB.Label, target As VB.PictureBox)
    target.CurrentX = lbl.left
    target.CurrentY = lbl.top
    Set target.Font = lbl.Font
    
    target.Print lbl.Caption
End Sub

'/**
' * copy a shape
' */
Private Sub cpyShape(shp As VB.Shape, target As VB.PictureBox)
    target.DrawWidth = shp.BorderWidth
    target.DrawStyle = getBorderStyleAsDrawStyle(shp.BorderStyle)
    target.FillColor = shp.FillColor
    target.FillStyle = shp.FillStyle
    
    'which shape?
    Select Case shp.Shape
        Case vbShapeCircle, vbShapeOval
            drawCircle shp, target
        Case vbShapeRectangle, vbShapeSquare
            drawRectangle shp, target
    End Select
End Sub
'/**
' * copy a shape
' */
Private Sub cpyLine(ln As VB.Line, target As VB.PictureBox)
    target.DrawWidth = ln.BorderWidth
    target.DrawStyle = getBorderStyleAsDrawStyle(ln.BorderStyle)
    
    target.Line (ln.X1, ln.Y1)-(ln.X2, ln.Y2), ln.BorderColor
End Sub
'/**
' * draw a circle
' */
Private Sub drawCircle(shp As VB.Shape, target As VB.PictureBox)
    Dim x As Single, y As Single, radius As Single, aspect As Double
    Dim width As Single, height As Single
    Dim coordinates As rect
    Dim kfactor As Double    ' conversion factor for x-units to y-units
    
    coordinates = getSquareShapeRects(shp, CBool(shp.Shape = vbShapeCircle))
    
    width = coordinates.right - coordinates.left
    height = coordinates.bottom - coordinates.top
    
    ' Compute conversion factor of x-axis units to y-axis units.
    kfactor = (target.ScaleWidth / target.ScaleHeight) * (target.ScaleHeight / target.ScaleWidth)
    
    
    'radius = IIf((shp.width > shp.height), shp.height / 2, shp.width / 2)

    x = coordinates.left + (width / 2)
    y = coordinates.top + (height / 2)
    
    'aspect = height / width
    
    ' Compute aspect ratio and radius.
    aspect = kfactor * height / width
    If aspect < 1 Then
        radius = height
    ElseIf aspect > 1 Then
        radius = kfactor * width
    Else
        radius = width / 2
    End If
    
    target.Circle (x, y), radius, shp.BorderColor, , , aspect
End Sub

'/**
' * draw the rectangle
' */
Private Sub drawRectangle(shp As VB.Shape, target As VB.PictureBox)
    Dim coordinates As rect
    
    coordinates = getSquareShapeRects(shp, CBool(shp.Shape = vbShapeSquare))
   
    If shp.FillStyle = vbFSSolid Then
        target.Line (coordinates.left, coordinates.top)-(coordinates.right, coordinates.bottom), shp.FillColor, BF
    End If
    
    target.Line (coordinates.left, coordinates.top)-(coordinates.right, coordinates.bottom), shp.BorderColor, B
End Sub

'/**
' * Returns the draw Style
' */
Private Function getBorderStyleAsDrawStyle(style As BorderStyleConstants) As DrawStyleConstants
    Select Case style
        Case vbTransparent '0
            getBorderStyleAsDrawStyle = vbInvisible
        Case vbBSSolid '1
            getBorderStyleAsDrawStyle = vbSolid
        Case vbBSDash '2
            getBorderStyleAsDrawStyle = vbDash
        Case vbBSDot '3
            getBorderStyleAsDrawStyle = vbDot
        Case vbBSDashDot '4
            getBorderStyleAsDrawStyle = vbDashDot
        Case vbBSDashDotDot '5
            getBorderStyleAsDrawStyle = vbDashDotDot
        Case vbBSInsideSolid '6
            getBorderStyleAsDrawStyle = vbInsideSolid
    End Select
End Function

Function getSquareShapeRects(shp As VB.Shape, perfect As Boolean) As rect
    Dim ret As rect
    
    If perfect Then
        Dim lado As Single
        
        lado = IIf((shp.width > shp.height), shp.height, shp.width)
        
        ret.top = shp.top + ((shp.height - lado) / 2)
        ret.left = shp.left + ((shp.width - lado) / 2)
        ret.bottom = ret.top + lado
        ret.right = ret.left + lado
    Else
        ret.top = shp.top
        ret.left = shp.left
        ret.bottom = shp.top + shp.height
        ret.right = shp.left + shp.width
    End If
    
    getSquareShapeRects = ret
End Function
